### BEGIN LICENSE
# Copyright (C) 2012 <De Gaetano Andrea> <dega1999@yahoo.com>
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

import threading
import Queue
import urllib2
          
import gettext
from gettext import gettext as _
gettext.textdomain('protoborsa')

from gi.repository import Gtk # pylint: disable=E0611
import logging
logger = logging.getLogger('protoborsa')

from protoborsa_lib import Window
from protoborsa.AboutProtoborsaDialog import AboutProtoborsaDialog
from protoborsa.PreferencesProtoborsaDialog import PreferencesProtoborsaDialog
from protoborsa.SearchstockDialog import SearchstockDialog

import cairo
from pycha.line import LineChart

from protoborsa_lib import ystockquote
from threading import Timer
import glib
from protoborsa_lib import personaldata
from protoborsa_lib import utilities
from gi.repository import GObject
from gi.repository import Unity
from gi.repository import Dbusmenu

queue = Queue.Queue();
# See protoborsa_lib.Window.py for more details about how this class works
class ProtoborsaWindow(Window):
    __gtype_name__ = "ProtoborsaWindow"
    
    def finish_initializing(self, builder): # pylint: disable=E1002
        """Set up the main window"""
        super(ProtoborsaWindow, self).finish_initializing(builder)

        #self.AboutDialog = AboutProtoborsaDialog;
        self.PreferencesDialog = PreferencesProtoborsaDialog;
        self.SearchstockDialog = SearchstockDialog;
        self.liststock = builder.get_object('liststock');
        self.chartLabel = builder.get_object('chartLabel');
	self.toolbar = self.builder.get_object('toolbar');
	ctx = self.toolbar.get_style_context();
	ctx.add_class(Gtk.STYLE_CLASS_PRIMARY_TOOLBAR);
	self.launcher = Unity.LauncherEntry.get_for_desktop_id("extras-protoborsa.desktop");
	self.quicklist = Dbusmenu.Menuitem.new()
        self.data = []
        self.surface = None;
        self.cr = None;
        self.gtkArea = None;
        self.minyvalue = 0;
        self.maxyvalue = 0;
        self.xticks = [];
        utilities.createSettings();
        self.registeredStock = personaldata.getStockBookmarks();
        self.liststock.append(['Loading data','...','','','','']);
        if(len(self.registeredStock) == 0):
            self.liststock.clear();
	self.addQuickList('Reload');
	self.launcher.set_property('quicklist', self.quicklist);
	self.startLoading();
        glib.timeout_add(1000, self.loadStockData) #wait for interface loading...
    def setXTicks(self,daysToPlot):
        self.xticks = utilities.getAxisTicks(daysToPlot);
    def addQuickList(self,label):
	section_menu_item = Dbusmenu.Menuitem.new ()
	section_menu_item.property_set (Dbusmenu.MENUITEM_PROP_LABEL, "Reload")
	section_menu_item.property_set_bool (Dbusmenu.MENUITEM_PROP_VISIBLE, True)
	section_menu_item.connect('item_activated', self.manageQL,label);
	self.quicklist.child_append(section_menu_item)
    def manageQL(self, menu_item, obj, lab):
	if (lab == "Reload"):
		self.reloadMe();
    def loadStockData(self):
        print "Loading stock data...";
        self.liststock.clear();
        results=[];
        for oneStock in self.registeredStock:
        	t = ThreadUrl(queue,results)
        	t.setDaemon(True)
        	t.start()
        for oneStock in self.registeredStock:
            queue.put(("table",oneStock[0],oneStock[1])) # add to queue
        queue.join();
        for i in results:
            res = i;
            self.liststock.append([res['symbol'],res['naming'],str(res['price'])+' $',str(float(res['volume'])/1000000)+' Mio',res['market_cap'],str(float(res['avg_daily_volume'])/1000000)]);
	print "LEN " + str(len(results));
        if(len(results)!=0):
            self.getDataToPlot(results[0]['symbol'],results[0]['naming']);
	else:
	    self.connectionFault();
	print "Loading data finished";
    def startLoading(self):
	print "startLoading called";
	self.launcher.set_property("progress", 0.3)
	self.launcher.set_property("progress_visible", True)
    def middleLoading(self):
	self.launcher.set_property("progress_visible", True)
	self.launcher.set_property("progress",0.60);
    def finishLoading(self):
     	self.launcher.set_property("progress_visible", False);
    def connectionFault(self):
	self.liststock.clear();
	self.liststock.append(['Unable to connect to Yahoo Finance.','...','','','','']);
	self.liststock.append(['Check your internet connection and press reload.','...','','','','']);
    def on_about_clicked(self,widget):
        print "about clicked";
        self.AboutDialog = AboutProtoborsaDialog;
        if self.AboutDialog is not None:
            aboutDlg = AboutProtoborsaDialog();
            aboutDlg.run();
            aboutDlg.destroy();
    def on_reload_clicked(self,widget):
	    self.reloadMe();
    def reloadMe(self):
	    self.startLoading();
            self.liststock.clear();
            self.liststock.append(['Reloading data','...','','','','']);
            results=[];
            queue = Queue.Queue()
            self.registeredStock = personaldata.getStockBookmarks();
            for oneStock in self.registeredStock:
            	t = ThreadUrl(queue,results)
            	t.setDaemon(True)
            	t.start()
            for oneStock in self.registeredStock:
                queue.put(("table",oneStock[0],oneStock[1])) # add to queue
            queue.join();
	    self.middleLoading();
            self.liststock.clear();
            #print "Results " + str(len(results));
            for i in results:
                res = i;
                #print "Record... "+str(res);
                self.liststock.append([res['symbol'],res['naming'],str(res['price'])+' $',str(float(res['volume'])/1000000)+' Mio',res['market_cap'],str(float(res['avg_daily_volume'])/1000000)]);
	    if (len(results)==0):
		self.connectionFault();
	    self.finishLoading();
    def on_showsearch_clicked(self,widget):
        print "on click for add dialog";
	self.startLoading();
        if self.SearchstockDialog is not None:
            searchDlg = self.SearchstockDialog()
	    self.middleLoading();
            response = searchDlg.run()
	    self.finishLoading();
            #print "RESP " + str(response);          
            if( response == Gtk.ResponseType.OK ):
                print "pressed ok! ";
                res = searchDlg.selectedStock();
                if(res != None): #and is not already present...
                    searchDlg.destroy();
                    results=[];
                    queue = Queue.Queue()
                    t = ThreadUrl(queue,results)
                    t.setDaemon(True)
                    t.start()
                    queue.put(("table",res[0],res[1]))
                    personaldata.insertStockBookmark(res[0]);
                    queue.join();
                    #print "Results " + str(len(results));
                    for i in results:
                        resMe = i;
                        self.liststock.append([resMe['symbol'],resMe['naming'],str(resMe['price'])+' $',str(float(resMe['volume'])/1000000)+' Mio',resMe['market_cap'],str(float(resMe['avg_daily_volume'])/1000000)]);
                    return;
            if( response == Gtk.ResponseType.CANCEL ):
                print "pressed Cancel!"
            searchDlg.destroy()
	self.finishLoading();
    def onStockSelectionChanged(self,widget):
        print "Selection changed";
        if(widget == None):
            return;
        selection = widget.get_selection();
        if(selection == None):
            return;
        model, tree_iter = selection.get_selected()
        if(tree_iter == None):
            return None;
	self.startLoading();
	self.chartLabel.set_text("Downloading data to plot..."); 
        symbol = model.get_value(tree_iter, 0);
        naming = model.get_value(tree_iter, 1);
        self.getDataToPlot(symbol,naming);
 
    def on_deleteStock_clicked(self,widget):
        print 'deletestock';
        model, tree_iter =  widget.get_selection().get_selected()
        if(tree_iter == None):
            print 'Selection null';
            return None;
        print 'Selection not null';
        toDelete = model.get_value(tree_iter, 0);
        personaldata.deleteStockBookmark(toDelete);
        model.remove(tree_iter);

    def onDrawEvent(self, widget, event):
        self.gtkArea = widget;
        self.cr = widget.get_property('window').cairo_create()
        dim = widget.get_allocation()
        #widgetDim = get_property('window').get_allocation()
        self.surface = cairo.ImageSurface(cairo.FORMAT_ARGB32, dim.width, dim.height)
        self.plotOnCanvas()

    def plotOnCanvas(self):
        if(len(self.data) == 0):
            return;
        points = (('Data', self.data),)
        options = {
            'axis' : { 'x': { 'ticks': self.xticks, 'label': 'Last Month' } , 'y': { 'range': [self.minyvalue, self.maxyvalue], 'label' : 'Dollars' }  },
            'background': {
                'color': '#eeeeff',
                'lineColor': '#444444'
            },
            'colorScheme': {
                'name': 'gradient',
                'args': {
                    'initialColor': 'blue',
                },
            },
            'legend': {
                'hide': True,
            },
        }
        chart = LineChart (self.surface, options)
        chart.addDataset(points)
        chart.render()
        print "plotting"
        self.cr.set_source_surface (self.surface, 0, 0)
        self.cr.paint ()

    def data4Chart(self,symbol,naming):
	results=[];
	queue = Queue.Queue()
	t = ThreadUrl(queue,results)
	t.setDaemon(True)
	t.start()
	queue.put(("chart",symbol,naming));
	queue.join();
	return results[0];

    def getDataToPlot(self,symbol,naming):
        '''print "Downloading from " + utilities.getLastMonth4YBegin() + " to " +utilities.getLastMonth4YEnd() ;         
        GOOG = ystockquote.get_historical_prices(symbol,  utilities.getLastMonth4YBegin(), utilities.getLastMonth4YEnd());'''
	print 'download data to plot......';
	self.middleLoading();
	threadData = self.data4Chart(symbol,naming);
	GOOG = threadData['plotData'];
	self.chartLabel.set_text("Last Month of " + naming);
        self.data = [ ];
        # Populate lists from downloaded data
        #print len(GOOG)
        days = [];
        field = 6;
        self.maxyvalue = 0;
        self.minyvalue = 0;
        reverse = 0;
        if(len(GOOG)>1):
            self.maxyvalue = float(GOOG[1][field]);
            self.minyvalue = float(GOOG[1][field]);
            reverse = len(GOOG)-1;
        for i in range(1,len(GOOG)-1):
            reverse=reverse-1;
            yValue = float(GOOG[reverse][field]);
            days.append(utilities.getDayMonth(GOOG[reverse][0]));
            self.data.append([i-1,yValue]);
            if(yValue > self.maxyvalue):
                self.maxyvalue = yValue;
            if(yValue < self.minyvalue):
                self.minyvalue = yValue;
        if self.minyvalue>2:
            self.minyvalue = self.minyvalue - 2;
        self.maxyvalue = self.maxyvalue + 2;
        self.setXTicks(days);
        print "Download complete"
        #print self.data;
        self.plotOnCanvas()
        self.gtkArea.queue_draw()
	self.finishLoading();
class ThreadUrl(threading.Thread):
    def __init__(self, queue,result):
        threading.Thread.__init__(self)
        self.queue = queue
        self.result = result;
    def run(self):
        while True:
            z = self.queue.get() #grab a tupla (type,symbols,naming) from queue. type is ( data for ) "table" or "chart".
            symbol = z[1];
	    stockdata = {};
            #print "symbol proc: "+str(symbol);
	    try:
	    	if(z[0] == "table"):
            		stockdata = ystockquote.get_all(symbol);
	    	elif(z[0] == "chart"):
	    		stockdata['plotData'] = ystockquote.get_historical_prices(symbol, utilities.getLastMonth4YBegin(), utilities.getLastMonth4YEnd());
		else:
			self.queue.task_done();
			return;
		if(len(stockdata) != 0):
			stockdata['symbol'] = symbol;
            		stockdata['naming'] = z[2];
			self.result.append(stockdata);
	    except:
	    	self.result = [];
            print len(self.result);
            #print "symbol done: "+str(symbol);
            self.queue.task_done()
