import sys
import sqlite3 as sql3
from protoborsa_lib import utilities;

def selectAndFetchQuery(query):
	results=[];
	con = getDbConnection();
	with con:
		cur = con.cursor()
		try:		
			cur.execute(query)
			results = cur.fetchall();
		except Exception:
			print "Errore Reading Data from user DB";
		pass
	con.close()
	return results;

def executeQuery(query):
	con = getDbConnection()
	con.execute(query)
	con.commit()
	con.close()

# select Naming from stockbookmark A join symbols T where A.symbol = T.symbol ;
def getStockBookmarks():
	return selectAndFetchQuery("select T.Symbol, Naming from stockbookmark A join symbols T where A.symbol = T.symbol ;");

def getAllStockSymbols():
	return selectAndFetchQuery("select Symbol, Naming from symbols;");

def getAllStockSymbolsPattern(pattern):
	return selectAndFetchQuery("select Symbol, Naming from symbols where lnaming like '"+pattern+"%';" );

def getDbConnection():
	return sql3.connect(utilities.getDbPath());#'./data/db/stocksymbols.db');

def deleteStockBookmark(symbol):
	return executeQuery("DELETE from stockbookmark where Symbol = '"+symbol+"'");

def insertStockBookmark(symbol):
	return executeQuery("INSERT INTO stockbookmark VALUES ('"+symbol+"');");
